(defclass preproc (cxml:sax-proxy) ())

(defmethod sax:characters ((handler preproc) data)
  (let ((parts (cl-ppcre:split "\\|" data)))
    ;; check this on edge cases, though, e.g., "", "|", "a|", strings
    ;; without any "|", etc.
    (call-next-method handler (pop parts))
    (dolist (part parts)
      (sax:start-element handler nil nil "bar" '())
      (sax:end-element handler nil nil "bar")
      (call-next-method handler part))))

(defun foo ()
  (with-open-file (out #P"teste.xml" :if-exists :supersede :direction :output)
    (let ((h (make-instance 'preproc :chained-handler (cxml:make-character-stream-sink out))))
      (cxml:parse #P"harem.xml" h :validate t))))